uniform sampler2D arrowTex;
uniform sampler2D xTex;
uniform sampler2D yTex;
uniform sampler2D velTex;

uniform vec2 pos;

uniform int mirrored;

void main(void)
 {	
	vec4 dir;
	vec2 dir2;
	//dir=(texture2D(velTex,pos.xy)-0.5);
	dir.x=(texture2D(xTex,pos.xy)-0.5).r;
	dir.y=(texture2D(yTex,pos.xy)-0.5).r;
	
	if (mirrored==1) {
		dir2=dir.xy;
	} else {
		dir2=vec2(dir.y, dir.x);
	}	
	
	dir2=normalize(dir2);
	//dir2.x=1.0;
	
	float alpha=acos(dir2.x);
	if (dir2.y<0.0) {
		alpha=2.0*3.1415-alpha;
	}
	
	//float alpha=atan(dir2.y/dir2.x);
	
 
	mat3 rotMatrix;
	rotMatrix[0]=vec3(cos(alpha),-sin(alpha),0.0);
	rotMatrix[1]=vec3(sin(alpha),cos(alpha),0.0);
	rotMatrix[2]=vec3(0.0,0.0,0.0);
	
	vec3 texCoords=gl_TexCoord[0].xyz;
	
	texCoords.x-=0.5;
	texCoords.y-=0.5;
	
	texCoords=texCoords* rotMatrix;
	
	texCoords.x+=0.5;
	texCoords.y+=0.5;
 
	//vec4 color=texture2D(arrowTex,gl_TexCoord[0].xy);
	vec4 color=texture2D(arrowTex,texCoords.xy);
	if (color.r==1.0 && color.g==0.0 && color.b==1.0) {
		color=vec4(0.0,0.0,0.0,0.0);
	}
	
	//if (dir.y<0.0) {
	//	color=vec4(abs(dir2.y),0.0,0.0,1.0);
	//}
	
	gl_FragColor=color;
	//gl_FragColor=vec4(color.r,dir2.x,dir2.y,1.0);

	 
 }
